; Viking quest 1 disassembled by IDA pro
; Processor	  : z80	[]
; Target assembler: Zilog Macro	Assembler

	DEVICE ZXSPECTRUM128
	ENCODING DOS
	
	MACRO IDADR id,adr
	 db id
	 dw adr
	ENDM

	ORG 0xc000,0
	include "data.asm"
	savebin "obj/page0.bin",0xc000,$-0xc000

	ORG 0xc000,1
	incbin "map.bin"
	savebin "obj/page1.bin",0xc000,$-0xc000
	
	org 0xc000,4
	include "pt3xplayer.asm"
muzAdrs	dw muz0,muz1
muz0	incbin "menu.pt3"
muz1	incbin "ingame.pt3"
	savebin "obj/page4.bin",0xc000,$-0xc000
	
	ORG 0xc000,6
	include "extend.asm"
	savebin "obj/page6.bin",0xc000,$-0xc000
	
		ORG 0x6161,0
begin
		jp	intHandle
start		jp	startGame
goMenu		jp	startMenu
		
word_616A:	dw 0			; here must be next sec/trk for final movie loading

		jp	exitGame
		
intHandle:	di
		push	af
		push	bc
		push	de
		push	hl
		ex	af, af'
		exx
		push	af
		push	bc
		push	de
		push	hl
		push	ix
		push	iy
		ld	a, (rmArrow)
		push	af
		call	rmArrow
crsFlag	scf
		call	nc, swMenuCursor
		ld	a, (curBank)
		push	af
		call	wrkBank
aniFlag:	scf
		call	nc, animate
		pop	af
		ld	b, a
		pop	af
		push	bc
		and	a
		call	z, putArrow
		ld	a, 4
		call	setBank
		ld	a, (0xC000)
		cp	21h
		jr	nz, loc_61AC
muzFlag:	scf
		call	nc, p1.muzPlay
loc_61AC:	pop	af
		call	setBank
		pop	iy
		pop	ix
		pop	hl
		pop	de
		pop	bc
		pop	af
		exx
		ex	af, af'
		pop	hl
		pop	de
		pop	bc
		pop	af
		ei
		ret

; on/off animation
aniOn:		ld	a, 0A7h
		jr	loc_61C6
aniOff:		ld	a, 37h
loc_61C6:	ld	(aniFlag), a
		ret
		
; on/off music
muzOn:		ld	a, 0A7h
		jr	loc_61D0
muzOff:		ld	a, 37h
loc_61D0:	ld	(muzFlag), a
		ret
		
; colors of map screens
mapColors:	db 6, 6, 6, 6, 6, 6, 5,	6, 1, 1, 1, 1, 1, 1, 6,	6
		db 6, 6, 6, 6, 6, 6, 6,	6, 6, 6, 6, 6, 6, 6, 4,	5
		db 5, 5

; game start
startMenu:	ld	a, 6
		call	setBank
loc_61FB:	ld	sp, 0x5fff
		jp	ext_C000
		
exitGame:	call	muzOff
		call	aniOff
resetAY:	ld	d, 0
		ld	a, 8
loc_620B:	ld	bc, 0FFFDh
		out	(c), a
		ld	b, 0BFh
		out	(c), d
		inc	a
		cp	0Bh
		jr	c, loc_620B
		ret

startGame:	ld	(loc_61FB+1), sp
		ld	c, 1
		call	setMusic
		call	sub_6D9B
		ld	(loc_6280+1), sp
		ld	hl, 5800h
		ld	de, 5801h
		ld	bc, 2FFh
		ld	(hl), l
		ldir
		ld	hl, pakSkin
		ld	de, freeSpace
		call	deHrust2
		ld	hl, freeSpace
		ld	de, 4000h
		ld	bc, 1B00h
		ldir
		call	findHero
		call	drawBag
		call	outStats
		xor	a
		call	loc_70A4
		ei
		xor	a
		call	setMap
		call	aniOn
loc_625F:	halt
		call	inKeys
		ld	c, a
		ld	hl, stru_63DD
loc_6267:	ld	a, (hl)
		and	a
		jr	z, loc_625F
		inc	hl
		cp	c
		jr	z, loc_6273
		inc	hl
		inc	hl
		jr	loc_6267
loc_6273:	call	ldHL_HL
		ld	a, h
		or	l
		jp	z, rmAllNPC
		call	callHL
		jr	loc_625F
loc_6280:	ld	sp, 0
		ld	a, 12h
		ld	(ix+1),	a
		ld	(ix+2),	22h
		call	setMap
		ld	a, 0Bh
		call	setNPCani
		call	sub_6D7B
		call	aniOff
		ld	hl, txtFinal
		call	printString
		call	rmAllNPC
		call	muzOff
		ld	a, 4
		call	setBank
		call	p1.muzMute
		ld	a, 6
		call	setBank
		jp	ext_C003

txtFinal:	db "      ",2
		db ".      -  ",2
		db "     ",2
		db ",    ,    ",2
		db " ",1,2,2
		db "          ",1
		db    0
		
inKeys:		ld	a, 0xFE
		in	a, (0xFE)
		rra
		ld	hl, stru_63BD
		jr	nc, loc_63A6
		ld	hl, stru_63CA
loc_63A6:	ld	a, (hl)
		and	a
		jr	z, inKeys
		cp	1
		jr	nz, loc_63B3
		ld	hl, stru_63CA
		jr	loc_63A6
loc_63B3:	in	a, (0xFE)
		inc	hl
		and	(hl)
		inc	hl
		ld	a, (hl)
		inc	hl
		jr	nz, loc_63A6
		ret

stru_63BD:	db 0xF7, 0x10, 8
		db 0xEF, 0x04, 9
		db 0xEF, 0x10, 10
		db 0xEF, 0x08, 11
		db 1
stru_63CA:	db 0xEF, 0x01, 32
		db 0x7F, 0x01, 32
		db 0xFB, 0x01, 11
		db 0xFD, 0x01, 10
		db 0xDF, 0x02, 8
		db 0xDF, 0x01, 9
		db 0

stru_63DD:	IDADR 11, movUp
		IDADR 10, movDown
		IDADR 8, movLeft
		IDADR 9, movRight
		IDADR 32, spcAction
		db    0

movDown:	xor	a
		jr	loc_63FA
movUp:		ld	a, 1
		jr	loc_63FA
movLeft:	ld	a, 2
		jr	loc_63FA
movRight:	ld	a, 3
loc_63FA:	cp	(ix+3)
		jr	nz, loc_6426
		push	af
		call	getNpcAhead
		jr	nc, loc_641F
		ld	a, l
		cp	90h
		jr	nz, loc_641F
		ld	hl, (doorTabAdr)
loc_640D:	ld	a, (hl)
		cp	0FFh
		jr	z, loc_641F
		inc	hl
		cp	d
		jr	nz, loc_641A
		ld	a, (hl)
		cp	e
		jr	z, loc_642E
loc_641A:	inc	hl
		inc	hl
		inc	hl
		jr	loc_640D
loc_641F:	pop	af
		call	setNPCani
		jp	sub_6D7B
loc_6426:	call	setNpcSprite
		halt
		halt
		halt
		halt
		ret
loc_642E:	pop	af
		ld	a, (ix+3)
		push	af
		push	hl
		ld	a, e
		ld	(stru_C212+2), a
		ld	a, d
		ld	(stru_C212+1), a
		ld	a, 64h
		ld	d, 0
		call	0F2BFh
loc_6443:	halt
		ld	a, (stru_C212+4)
		inc	a
		jr	nz, loc_6443
		ld	a, 0FFh
		ld	(stru_C212+1), a
		call	aniOff
		call	aniF4
		call	aniF0
		ld	a, 0FFh
		call	setNpcSprite
		ld	hl, 4021h
		ld	b, 40h
loc_6462:	halt
		ld	c, 10h
		ld	a, l
loc_6466:	ld	(hl), 0
		inc	l
		dec	c
		jr	nz, loc_6466
		ld	l, a
		call	nextHL
		call	nextHL
		djnz	loc_6462
		pop	hl
		inc	hl
		ld	a, (hl)
		ld	(ix+0Ah), a
		ld	(curMap), a
		inc	hl
		ld	l, (hl)
		ld	(ix+0Bh), l
		call	setMap
		call	aniF6
		pop	af
		call	setNpcSprite
		call	aniOn
		halt
		halt
		halt
		halt
		ret
		
spcAction:	call	noKey
		call	noMove
		call	putArrow
loc_649E:	call	arrKeys
		jr	nc, loc_649E
		ld	de, (arrowXY+1)
		ld	hl, clickZoneTab
		xor	a
loc_64AB:	ex	af, af'
		ld	c, l
		ld	b, h
		ld	a, e
		sub	(hl)
		cp	e
		jr	z, loc_649E
		inc	hl
		cp	(hl)
		jr	nc, loc_64BE
		inc	hl
		ld	a, d
		sub	(hl)
		inc	hl
		cp	(hl)
		jr	c, loc_64C6
loc_64BE:	ld	hl, 4
		add	hl, bc
		ex	af, af'
		inc	a
		jr	loc_64AB
loc_64C6:	push	af
		call	noKey
		pop	af
		ld	hl, zoneCallTab
		ex	af, af'
		call	sub_6614
		jr	c, loc_649E
		call	rmArrow
noKey:		xor	a
		in	a, (0FEh)
		cpl
		and	1Fh
		jr	nz, noKey
		ret

waitKey:
		xor	a
		in	a, (0FEh)
		cpl
		and	1Fh
		jr	z, waitKey
		ret
		
clickZoneTab:	db 0x08, 128, 0x08, 128
		db 0x98, 24, 0x08, 24
		db 0x98, 24, 0x20, 24
		db 0xB0, 24, 0x08, 24
		db 0xB0, 24, 0x20, 24
		db 0xC8, 24, 0x08, 24
		db 0xC8, 24, 0x20, 24
		db 0xE0, 24, 0x20, 24
		db 0xB0, 16, 0x68, 16
		db 0xC8, 16, 0x68, 16
		db 0xE2, 16, 0x68, 16
		db 0

zoneCallTab:	dw backToMap
		dw backToMap
		dw actTalk
		dw actItem
		dw actFight
		dw actUse
		dw actMagic
		dw actExit
		dw selItem0
		dw selItem1
		dw selItem2
		
backToMap:	and	a
		ret

actItem:	call	getNpcAhead
		jr	nc, loc_655E
		ld	c, l
		ld	hl, (tPickTabAdr)
loc_6537:	ld	a, (hl)
		cp	0FFh
		jr	z, loc_6548
		cp	c
		inc	hl
		jr	z, loc_6544
		inc	hl
		inc	hl
		jr	loc_6537
loc_6544:	call	ldHL_HL
		jp	(hl)
loc_6548:	ld	a, c
		rla
		ret	c
		call	getCurItem
		ld	a, b
		and	a
		scf
		ret	z
		ld	c, a
		ld	b, 0
		ld	hl, (dropTabAdr)
		add	hl, bc
		add	hl, bc
		call	ldHL_HL
		jp	(hl)
loc_655E:	ld	c, a
		call	getCurItem
		ld	hl, (giveTabAdr)
loc_6565:	ld	a, (hl)
		cp	0FFh
		scf
		ret	z
		cp	c
		inc	hl
		ld	a, (hl)
		inc	hl
		jr	nz, loc_6577
		cp	0FFh
		jr	z, loc_657B
		cp	b
		jr	z, loc_657B
loc_6577:	inc	hl
		inc	hl
		jr	loc_6565
loc_657B:	call	ldHL_HL
		jp	(hl)
		
actFight:	scf
		ret
		
actUse:		call	getNpcAhead
		jr	nc, loc_6588
		ld	a, 0FFh
loc_6588:	ld	(loc_65A3+1), a
		ld	d, (ix+1)
		ld	e, (ix+2)
		ld	hl, (useTabAdr)
		call	getCurItem
loc_6597:	ld	a, (hl)
		cp	0FFh
		scf
		ret	z
		cp	0FEh
		jr	nz, loc_65A7
		push	hl
		inc	hl
		ld	a, (hl)
loc_65A3:	cp	0FFh
		jr	loc_65AE
loc_65A7:	push	hl
		cp	d
		jr	nz, loc_65B5
		inc	hl
		ld	a, (hl)
		cp	e
loc_65AE:	jr	nz, loc_65B5
		inc	hl
		ld	a, (hl)
		cp	b
		jr	z, loc_65BD
loc_65B5:	pop	hl
		inc	hl
		inc	hl
		inc	hl
		inc	hl
		inc	hl
		jr	loc_6597
loc_65BD:				
		pop	af
		inc	hl
		call	ldHL_HL
		jp	(hl)
actMagic:				
		ld	a, (ix+0)
		cp	1
		scf
		ret	nz
		ld	hl, (magicTabAdr)
		ld	d, (ix+1)
		ld	e, (ix+2)
loc_65D3:				
		ld	a, (hl)
		cp	0FFh
		scf
		ret	z
		cp	d
		inc	hl
		jr	nz, loc_65E0
		ld	a, (hl)
		cp	e
		jr	z, loc_65E5
loc_65E0:				
		inc	hl
		inc	hl
		inc	hl
		jr	loc_65D3
loc_65E5:				
		inc	hl
		call	ldHL_HL
		jp	(hl)
actExit:				
		call	rmAllNPC
		call	noKey
		jp	startMenu
actTalk:				
		call	getNpcAhead
		ret	c
		push	af
		call	noKey
		pop	af
		ld	hl, (talkTabAdr)
		ld	e, a
loc_6600:	ld	a, (hl)
		cp	80h
		ccf
		ret	c
		inc	hl
		cp	e
		jr	z, loc_660D
		inc	hl
		inc	hl
		jr	loc_6600
loc_660D:				
		call	ldHL_HL
		push	hl
		jp	rmArrow
; =============== S U B	R O U T	I N E =======================================
sub_6614:				
		ld	e, a
		ld	d, 0
		add	hl, de
		add	hl, de
		call	ldHL_HL
		jp	(hl)
; End of function sub_6614
; =============== S U B	R O U T	I N E =======================================
printString:				
		ld	de, 0E12h
		ld	(printPos+1), de
loc_6624:	ld	a, (hl)
		and	a
		jp	z, loc_66AB
		inc	hl
		cp	4
		jr	c, loc_6635
		cp	20h
		call	nc, printChar
		jr	loc_6624
loc_6635:	push	hl
		ld	hl, off_664A
		ld	c, a
		ld	b, 0
		add	hl, bc
		add	hl, bc
		call	ldHL_HL
		ld	(loc_6645+1), hl
		pop	hl
loc_6645:	call	aniF8
		jr	loc_6624
		
off_664A:	dw aniF8	; 0 : end	
		dw txt01	; 1 : next page
		dw txt02	; 2 : CRLF
		dw txt03	; 3,n : out icon
txt03:				
		ld	a, (hl)
		inc	hl
		push	hl
		push	de
		ld	l, a
		ld	h, 0
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		ld	e, l
		ld	d, h
		add	hl, hl
		add	hl, hl
		add	hl, de
		ld	de, (avaDataAdr)
		add	hl, de
		ld	de, 5041h
		ld	bc, 5FFh
loc_666E:	ld	a, e
		ldi
		ldi
		ldi
		ldi
		ld	e, a
		inc	d
		ld	a, d
		and	7
		jr	nz, loc_666E
		ld	a, e
		add	a, 20h
		ld	e, a
		ld	a, d
		sub	8
		ld	d, a
		djnz	loc_666E
		pop	de
		pop	hl
		ret
		
txt01:		call	waitKey
		call	noKey
		call	sub_66B4
		ld	de, 0E12h
		ld	(printPos+1), de
		jp	noMove
		
txt02:		ld	a, (printPos+1)
		inc	a
		ld	(printPos+1), a
		ld	a, 0Eh
		ld	(printPos+2), a
		ret
		
loc_66AB:	push	hl
		ld	hl, 5041h
		ld	bc, 281Eh
		jr	loc_66BB
sub_66B4:	push	hl
		ld	hl, 5047h
		ld	bc, 2818h
loc_66BB:	ld	a, l
		push	bc
loc_66BD:	ld	(hl), 0
		inc	l
		dec	c
		jr	nz, loc_66BD
		pop	bc
		ld	l, a
		call	nextHL
		djnz	loc_66BB
		pop	hl
		ret
		
printS		xor	a
printChar:	push	bc
		push	de
		push	hl
		ld	l, a
		ld	h, 0
		ld	de, font600
		add	hl, de
printPos:	ld	bc, 0
		srl	b
		push	af
		ld	a, c
		rrca
		rrca
		rrca
		and	0E0h
		or	b
		ld	e, a
		ld	a, c
		and	18h
		or	41h
		ld	d, a
		pop	af
		ld	bc, 60Fh
		jr	nc, loc_66F3
		ld	c, 0F0h
loc_66F3:	ld	a, (de)
		and	c
		ld	(de), a
		ld	a, c
		cpl
		and	(hl)
		ex	de, hl
		or	(hl)
		ld	(hl), a
		ex	de, hl
		inc	h
		inc	d
		djnz	loc_66F3
		ld	hl,  printPos+2
		inc	(hl)
		pop	hl
		pop	de
		pop	bc
		ret
; End of function printChar

font600:	incbin "font4x6.bin"

; out:	CY=1 : no NPC ahead
;	CY=0 : A = npcID, L = tile.nr.under.npc

getNpcAhead:				
		ld	l, (ix+2)
		ld	a, (ix+3)
		and	a
		jr	z, loc_6D2E
		dec	a
		jr	z, loc_6D2A
		dec	a
		jr	z, loc_6D22
		ld	a, l
		and	7
		cp	7
		scf
		ret	z
		inc	l
		jr	loc_6D36
loc_6D22:	ld	a, l
		and	7
		scf
		ret	z
		dec	l
		jr	loc_6D36
loc_6D2A:	ld	a, 0F8h
		jr	loc_6D30
loc_6D2E:	ld	a, 8
loc_6D30:	add	a, l
		cp	40h
		ccf
		ret	c
		ld	l, a
loc_6D36:	ld	e, l
		ld	d, 0
		ld	hl, mapBuf
		add	hl, de
		ld	d, (ix+1)
		ld	l, (hl)
		ld	a, l
		sub	0FFh
		ret	c
		ld	d, (ix+1)
		push	ix
		ld	ix, (npcTabAdr)
		ld	bc, 20h
loc_6D51:	bit	7, (ix+0)
		jr	nz, loc_6D77
		ld	a, (ix+3)
		inc	a
		jr	z, loc_6D69
		ld	a, (ix+1)
		cp	d
		jr	nz, loc_6D69
		ld	a, (ix+2)
		cp	e
		jr	z, loc_6D6D
loc_6D69:	add	ix, bc
		jr	loc_6D51
loc_6D6D:	ld	a, (ix+0)
		ld	l, (ix+6)
		pop	ix
		and	a
		ret
loc_6D77:	pop	ix
		scf
		ret
; End of function getNpcAhead
; =============== S U B	R O U T	I N E =======================================
sub_6D7B:				
		halt
		ld	a, (ix+4)
		cp	0FFh
		ret	z
		bit	6, (ix+1Dh)
		jr	z, sub_6D7B
		ld	a, (ix+0Ah)
		call	setMap
		call	aniOn
		res	6, (ix+1Dh)
		res	7, (ix+1Dh)
		jr	sub_6D7B
; End of function sub_6D7B
; =============== S U B	R O U T	I N E =======================================
sub_6D9B:				
		call	wrkBank
		ld	hl, 0A0Dh
		ld	(stru_C132+1), hl
		ld	hl, 2521h
		ld	(stru_C0B2+1), hl
		ld	hl, 0FFFFh
		ld	(stru_C232+1), hl
		ld	(stru_C252+1), hl
		ld	(stru_C272+1), hl
		ld	(stru_C292+1), hl
		ld	l, 0
		ld	(stru_C032+3), hl
		ld	a, 0A7h
		ld	(loc_EEFE), a
		ld	(loc_F296), a
		ld	(loc_F149), a
		ld	a, 24h
		ld	(stru_C032+2), a
		ld	a, 5
		ld	(stru_C1B2+0x17), a
		xor	a
		ld	(stru_C1B2+3), a
		ld	(stru_C032+1), a
		ld	(stru_C032+3), a
		ld	(stru_C052+3), a
		ld	(stru_C112+3), a
		ld	(stru_C132+3), a
		ld	(stru_C132+4), a
		ld	(stru_C0B2+3), a
		ld	(stru_C0B2+4), a
		dec	a
		ld	(stru_C1B2+4), a
		ld	(stru_C112+4), a
		ld	(stru_C0F2+3), a
		ld	(stru_C0F2+4), a
		ld	ix, (npcTabAdr)
		ld	de, 20h
		ld	b, 2
loc_6E05:				
		ld	(ix+0Ch), d
		ld	(ix+0Dh), d
		ld	(ix+0Eh), d
		ld	(ix+17h), 1Fh
		ld	(ix+18h), d
		add	ix, de
		djnz	loc_6E05
		ld	a, 37h
		jp	putAllNPC
; End of function sub_6D9B
gameDeath	ld	sp, (loc_6280+1)
		halt
		ld	a, 0FFh
		call	setNpcSprite
		call	clsMapWin
		ld	a, 0Ch
		call	setNPCani
		ld	hl, fatalText
		call	printString
		call	aniOff
		call	rmAllNPC
		ld	a, 6
		call	setBank
		jp	ext_C006
		
fatalText:	db "       ",2
		db "   . -  - ",2
		db "  .      ",2
		db "  .   :",2
		db "'.  ...'",1
		db    0
		
; =============== S U B	R O U T	I N E =======================================
setMap:					
		push	af
		call	mapBank
		pop	af
		ld	(curMap), a
		call	getCurMapAdr
		ld	de, mapBuf
		ld	bc, 40h
		ldir
		ld	l, a
		ld	h, 0FCh
		ld	de, upMapNr
loc_6F2E:	ld	a, (hl)
		ld	(de), a
		inc	de
		inc	h
		jr	nz, loc_6F2E
		halt
		call	wrkBank
		ld	a, l
		push	ix
		call	rmAllNPC
		pop	ix
		ld	a, (aniFlag)
		push	af
		call	aniOff
		call	fillMapColor
		ld	a, (curMap)
		cp	8
		jr	nz, outMap
		ld	a, (ix+0)
		and	a
		jr	nz, outMap
		ld	a, 3
		call	checkItem
		jr	z, outMap
		call	clsMapWin
		ld	a, 9
		call	setNPCani
		jr	loc_6FB1

outMap:		ld	hl, mapBuf
		ld	de, 4021h
		ld	b, 8
loc_6F70:	ld	c, 8
loc_6F72:	push	bc
		push	de
		push	hl
		ld	l, (hl)
		ld	h, 0
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		ld	bc, tilesData
		add	hl, bc
		ld	bc, 2FFh
loc_6F84:	ldi
		ldi
		dec	e
		dec	e
		inc	d
		ld	a, d
		and	7
		jr	nz, loc_6F84
		ld	a, e
		add	a, 20h
		ld	e, a
		jr	c, loc_6F9A
		ld	a, d
		sub	8
		ld	d, a
loc_6F9A:	djnz	loc_6F84
		pop	hl
		pop	de
		pop	bc
		inc	hl
		inc	e
		inc	e
		dec	c
		jr	nz, loc_6F72
		ld	a, e
		add	a, 30h
		ld	e, a
		jr	nc, loc_6FAF
		ld	a, d
		add	a, 8
		ld	d, a
loc_6FAF:	djnz	loc_6F70
loc_6FB1:	push	ix
		ld	a, 0A7h
		call	putAllNPC
		pop	ix
		pop	af
		jp	loc_61C6

putAllNPC:	ld	ix, (npcTabAdr)
		ld	de, 20h
		ld	(loc_6FF8), a
loc_6FC8:	bit	7, (ix+0)
		ret	nz
		bit	7, (ix+3)
		jr	nz, loc_7001
		ld	c, (ix+2)
		ld	b, (ix+1)
		call	getCellAdr
		call	mapBank
		ld	b, (hl)
		ld	(hl), 0FFh
		call	wrkBank
		ld	(ix+6),	b
		ld	a, (curMap)
		cp	(ix+1)
		jr	nz, loc_7001
		ld	hl, mapBuf
		ld	b, 0
		add	hl, bc
		ld	(hl), 0FFh
loc_6FF8:	scf
		ld	a, (ix+3)
		push	de
		call	nc, drawNPCsprA
		pop	de
loc_7001:	add	ix, de
		jr	loc_6FC8

clsMapWin:	ld	hl, 4021h
		ld	b, 80h
loc_700A:	ld	c, 10h
		ld	a, l
loc_700D:	ld	(hl), 0
		inc	l
		dec	c
		jr	nz, loc_700D
		ld	l, a
		call	nextHL
		djnz	loc_700A
		ret

rmAllNPC:	ld	ix, (npcTabAdr)
		ld	de, 20h
		ld	b, d
loc_7022:	bit	7, (ix+0)
		ret	nz
		bit	7, (ix+3)
		jr	nz, loc_7054
		ld	(ix+5),	1
		ld	b, (ix+1)
		ld	c, (ix+2)
		call	getCellAdr
		ld	b, (ix+6)
		call	mapBank
		ld	(hl), b
		call	wrkBank
		ld	a, (curMap)
		cp	(ix+1)
		jr	nz, loc_7054
		ld	a, b
		ld	b, 0
		ld	hl, mapBuf
		add	hl, bc
		ld	(hl), a
loc_7054:	add	ix, de
		jr	loc_7022

fillMapColor:	ld	a, (curMap)
		ld	e, a
		ld	d, 0
		ld	hl, mapColors
		add	hl, de
		ld	a, (hl)
loc_7063	ld	hl, 5821h
		ld	de, 10h
		ld	b, e
loc_706A:	ld	c, e
loc_706B:	ld	(hl), a
		inc	l
		dec	c
		jr	nz, loc_706B
		add	hl, de
		djnz	loc_706A
		ret

getCurMapAdr:	ld	a, (curMap)
		ld	l, a
		ld	h, 0
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		ld	de, 0C000h
		add	hl, de
		ret

findHero:	ld	a, 0
findNPC:	ld	ix, (npcTabAdr)
		ld	bc, 20h
loc_708E:	cp	(ix+0)
		ret	z
		add	ix, bc
		jr	loc_708E

; === items

selItem0:	xor	a
		jr	loc_709F
selItem1:	ld	a, 1
		jr	loc_709F
selItem2:	ld	a, 2
loc_709F:	push	af
		call	xorItemCursor
		pop	af
loc_70A4:	ld	(curItemPos+1), a
xorItemCursor:	ld	a, (rmArrow)
		push	af
		call	rmArrow
		ld	h, 4Eh
curItemPos:	ld	a, 0FFh
		cp	0FFh
		jr	z, loc_70D8
		ld	b, a
		add	a, a
		add	a, b
		add	a, 95h
		ld	l, a
		call	xorICrsFF
		ld	b, 12h
		ld	de, 240h
loc_70C4:	ld	a, (hl)
		xor	d
		ld	(hl), a
		inc	l
		inc	l
		inc	l
		ld	a, (hl)
		xor	e
		ld	(hl), a
		dec	l
		dec	l
		dec	l
		call	nextHL
		djnz	loc_70C4
		call	xorICrsFF
loc_70D8:	pop	af
		and	a
		call	z, putArrow
		scf
		ret

xorICrsFF:	ld	a, (hl)
		xor	3
		ld	(hl), a
		inc	l
		ld	a, (hl)
		cpl
		ld	(hl), a
		inc	l
		ld	a, (hl)
		cpl
		ld	(hl), a
		inc	l
		ld	a, (hl)
		xor	0C0h
		ld	(hl), a
		dec	l
		dec	l
		dec	l
		ret

getCurItem:	ld	a, (curItemPos+1)
		ld	b, (ix+0Ch)
		and	a
		ret	z
		ld	b, (ix+0Dh)
		dec	a
		ret	z
		ld	b, (ix+0Eh)
		ret
		
delItem:	ld	a, (ix+0Ch)
		cp	d
		ld	(ix+0Ch), 0
		ret	z
		ld	(ix+0Ch), a
		ld	a, (ix+0Dh)
		cp	d
		ld	(ix+0Dh), 0
		ret	z
		ld	(ix+0Dh), a
		ld	a, (ix+0Eh)
		cp	d
		ld	(ix+0Eh), 0
		ret	z
		ld	(ix+0Eh), a
		ret

checkItem:	cp	(ix+0Ch)
		ret	z
		cp	(ix+0Dh)
		ret	z
		cp	(ix+0Eh)
		ret

addItem:	ld	a, d
		call	checkItem
		ret	z
		ld	a, (ix+0Ch)
		cp	d
		jr	z, loc_7164
		ld	(ix+0Ch), d
		and	a
		jr	z, loc_7164
		ld	(ix+0Ch), a
		ld	a, (ix+0Dh)
		cp	d
		jr	z, loc_7164
		ld	(ix+0Dh), d
		and	a
		jr	z, loc_7164
		ld	(ix+0Dh), a
		ld	a, (ix+0Eh)
		cp	d
		jr	z, loc_7164
		and	a
		ret	nz
		ld	(ix+0Eh), d
loc_7164:	call	drawBag
		scf
		ret
; =============== S U B	R O U T	I N E =======================================
drawBag:				
		ld	a, (ix+0Ch)
		ld	de, 48B6h
		call	drawItem
		ld	a, (ix+0Dh)
		ld	de, 48B9h
		call	drawItem
		ld	a, (ix+0Eh)
		ld	de, 48BCh
drawItem:	push	de
		ld	l, a
		ld	h, 0
		add	hl, hl
		add	hl, hl
		ld	c, l
		ld	b, h
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, bc
		ld	bc, itemSprites
		add	hl, bc
		ld	bc, 2FFh
loc_7194:	ldi
		ldi
		dec	e
		dec	e
		inc	d
		ld	a, d
		and	7
		jr	nz, loc_7194
		ld	a, e
		add	a, 20h
		ld	e, a
		jr	c, loc_71AA
		ld	a, d
		sub	8
		ld	d, a
loc_71AA:				
		djnz	loc_7194
		pop	de
		ld	a, d
		rra
		rra
		rra
		and	3
		or	58h
		ld	d, a
		ldi
		ldi
		ld	a, e
		add	a, 1Eh
		ld	e, a
		jr	nc, loc_71C1
		inc	d
loc_71C1:				
		ldi
		ldi
		ret
; End of function drawItem

addExp:		ld	a, (ix+18h)
		add	a, d
		jr	nc, loc_71CE
		ld	a, 0FFh
loc_71CE:	ld	(ix+18h), a
outStats:	ld	hl, 4A92h
		ld	a, (ix+17h)
		call	outBar
		ld	hl, 4A94h
		ld	a, (ix+18h)
		add	a, a
		call	outBar
		ld	hl, 4A93h
		ld	a, (ix+18h)
		rra
		rra
		rra
		and	1Eh
outBar:		and	1Fh
		cp	1Ch
		jr	c, loc_71F7
		ld	a, 1Ch
loc_71F7:	ld	c, a
		ld	d, 38h
		ld	b, 1Ch
loc_71FC:	ld	a, b
		cp	c
		ld	a, d
		jr	c, loc_7202
		xor	a
loc_7202:	ld	(hl), a
		call	nextHL
		ld	a, d
		xor	0Ch
		ld	d, a
		djnz	loc_71FC
		ret

; in	C = muz.nr
setMusic:				
		ld	a, (curBank)
		push	af
		call	muzOff
		ld	a, 4
		call	setBank
		push	bc
		call	p1.muzMute
		pop	bc
		ld	b, 0
		ld	hl, muzAdrs
		add	hl, bc
		add	hl, bc
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		call	p1.muzInit
		call	muzOn
		pop	af
		jp	setBank
; End of function setMusic

		include "animator.asm"

;-----------

getRandom:	push	hl
rndAdr:	ld	hl, 0
		inc	l
		ld	(rndAdr+1), hl
		ld	a, r
		xor	(hl)
		pop	hl
		ret

; in	B = map, C = coord (0..63)
; out	HL = adr on map
getCellAdr:	ld	l, b
		ld	h, 0
		ld	a, b
		ld	b, 0C0h
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, bc
		ld	b, a
		ret
		
; in	B = map, C = coord (0..63)
; out	A = D = tile nr on map
getCellTile:	call	mapBank
		call	getCellAdr
		ld	d, (hl)
		call	wrkBank
		ld	a, d
		ret

; in	IX = npcDSC, A = spr.num
setNpcSprite:	cp	(ix+3)
		ret	z
		push	af
		call	sub_74F3
		pop	af
		ld	(ix+3),	a
		cp	0FFh
		ret	z
drawNPCsprA:	ld	e, (ix+0Fh)
		ld	d, (ix+10h)
		ld	l, a
		ld	h, 0
		add	hl, hl
		add	hl, de
		call	ldHL_HL
		call	ldDE_HL
		ld	(ix+19h), e
		ld	(ix+1Ah), d
		call	ldDE_HL
		ld	(ix+1Bh), e
		ld	(ix+1Ch), d
		ld	a, (hl)
		ld	(ix+1Dh), a
		and	4
		jr	nz, loc_748C
		set	7, (ix+1Dh)
		call	loc_74FD
loc_748C:	ld	a, (curMap)
		cp	(ix+1)
		ret	nz
		call	npcScrAdr
		push	hl
		ld	e, (ix+1Bh)
		ld	d, (ix+1Ch)
		ld	a, (ix+1Ah)
		add	a, a
		add	a, a
		add	a, a
		ld	b, a
loc_74A4:	ld	c, (ix+19h)
		ld	a, l
		ex	af, af'
loc_74A9:	bit	0, (ix+1Dh)
		jr	z, loc_74B7
		ld	a, (de)
		and	(hl)
		ld	(hl), a
		inc	de
		ld	a, (de)
		or	(hl)
		jr	loc_74B8
loc_74B7:	ld	a, (de)
loc_74B8:	ld	(hl), a
		inc	de
		inc	l
		dec	c
		jr	nz, loc_74A9
		ex	af, af'
		ld	l, a
		inc	h
		ld	a, h
		and	7
		jr	nz, loc_74D0
		ld	a, l
		add	a, 20h
		ld	l, a
		jr	c, loc_74D0
		ld	a, h
		sub	8
		ld	h, a
loc_74D0:	djnz	loc_74A4
		pop	hl
		bit	1, (ix+1Dh)
		ret	z
		call	toAtr
		ld	b, (ix+1Ah)
		ld	c, (ix+19h)
loc_74E1:	push	bc
		push	hl
loc_74E3:	ld	a, (de)
		ld	(hl), a
		inc	l
		inc	de
		dec	c
		jr	nz, loc_74E3
		pop	hl
		ld	bc, 20h
		add	hl, bc
		pop	bc
		djnz	loc_74E1
		ret
		
; =============== S U B	R O U T	I N E =======================================
sub_74F3:	ld	a, (ix+1Dh)
		and	84h
		cp	80h
		ret	nz
		jr	loc_7504

loc_74FD:	set	7, (ix+1Dh)
		xor	a
		jr	loc_750A

loc_7504:	res	7, (ix+1Dh)
		ld	a, 0EBh
loc_750A:	ld	(loc_754C), a
		ld	(loc_754F), a
		ld	a, (curMap)
		cp	(ix+1)
		ret	nz
		ld	a, (curBank)
		push	af
		ld	a, (ix+0)
		or	80h
		scf
		ld	d, a
		ld	e, 0
		rr	d
		rr	e
		ld	a, (loc_754C)
		and	a
		ld	l, (ix+1Eh)
		ld	h, (ix+1Fh)
		call	z, npcScrAdr
		ld	(ix+1Eh), l
		ld	(ix+1Fh), h
		ld	a, (ix+1Ah)
		add	a, a
		add	a, a
		add	a, a
		ld	b, a
		ld	c, (ix+19h)
		ld	a, 3
		call	setBank
loc_754A:	push	hl
		push	bc
loc_754C:	nop
		ld	a, (hl)
		ld	(de), a
loc_754F:	nop
		inc	l
		inc	de
		dec	c
		jr	nz, loc_754C
		pop	bc
		pop	hl
		call	nextHL
		djnz	loc_754A
		pop	af
		jr	setBank
		
wrkBank:	ld	a, 0
		jr	setBank
mapBank:	ld	a, 1
setBank:	push	bc
		ld	bc, 7FFDh
		and	7
		ld	(curBank), a
		or	10h
		out	(c), a
		pop	bc
		ret

curBank:	db 0			

npcScrAdr:	ld	c, (ix+2)
		ld	a, c
		and	7
		add	a, a
		inc	a
		ld	b, a
		ld	a, c
		rrca
		rrca
		rrca
		and	7
		add	a, a
		inc	a
		ld	c, a
		bit	3, (ix+1Dh)
		jr	z, loc_758F
		dec	b
		dec	b
loc_758F:	bit	4, (ix+1Dh)
		jr	z, boxScrAdr
		dec	c
		dec	c
boxScrAdr:	ld	a, c
		rrca
		rrca
		rrca
		and	0E0h
		or	b
		ld	l, a
		ld	a, c
		and	18h
		or	40h
		ld	h, a
		ret

toAtr:		ld	a, h
		rra
		rra
		rra
		and	3
		or	58h
		ld	h, a
		ret

nextHL:		inc	h
		ld	a, h
		and	7
		ret	nz
		ld	a, l
		add	a, 20h
		ld	l, a
		ret	c
		ld	a, h
		sub	8
		ld	h, a
		ret

ldDE_HL:	ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		ret

ldHL_HL:	ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
aniF8:		ret

callHL:		jp	(hl)

curMap:		db 0		; current map
upMapNr:	db 0FFh		; neighbour maps
dnMapNr:	db 0FFh			
lfMapNr:	db 0FFh			
rgMapNr:	db 0FFh			
mapBuf:		ds 64		; map buffer

		ld	a, 7
		call	setBank
		ld	hl, freeSpace
		ld	de, 0C000h
		ld	bc, 1B00h
		ldir
		ld	a, 6
		jp	setBank

		include "dehrust2.asm"
		include "arrow.asm"

tilesData:	incbin "tiles.bin"
pakSkin:	incbin "titlescr.pak"
itemSprites:	incbin "items.bin"

	display "main\t",begin,",",$-begin," (",$,")"
	
	savebin "obj/main.6161.bin",begin,$-begin

	SAVESNA "vq1.sna",goMenu
	
freeSpace	equ $
